'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _class, _temp2;

var _joi = require('joi');

var _joi2 = _interopRequireDefault(_joi);

var _makeen = require('makeen');

var _File = require('./services/File');

var _File2 = _interopRequireDefault(_File);

var _FileRepository = require('./services/FileRepository');

var _FileRepository2 = _interopRequireDefault(_FileRepository);

var _router = require('./router');

var _router2 = _interopRequireDefault(_router);

var _upload = require('./middlewares/upload');

var _upload2 = _interopRequireDefault(_upload);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

let FileStorage = (_temp2 = _class = class FileStorage extends _makeen.Module {
  constructor(...args) {
    var _temp;

    return _temp = super(...args), this.name = 'makeen.fileStorage', _temp;
  }

  initialize({ uploadDir }) {
    this.uploadMiddleware = (0, _upload2.default)({
      dest: uploadDir
    });

    this.router = (0, _router2.default)({
      uploadMiddleware: this.uploadMiddleware
    });
  }

  setup() {
    var _this = this;

    return _asyncToGenerator(function* () {
      var _ref = yield _this.dependencies(['makeen.octobus', 'makeen.mongoDb']),
          _ref2 = _slicedToArray(_ref, 2);

      const registerServices = _ref2[0].registerServices,
            bindRepository = _ref2[1].bindRepository;


      const services = registerServices(_this, {
        File: new _File2.default({
          uploadDir: _this.getConfig('uploadDir')
        }),
        FileRepository: bindRepository(new _FileRepository2.default())
      });

      _this.export(services);
    })();
  }
}, _class.configSchema = {
  uploadDir: _joi2.default.string().required()
}, _temp2);
exports.default = FileStorage;