'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _boom = require('boom');

var _boom2 = _interopRequireDefault(_boom);

var _joi = require('joi');

var _joi2 = _interopRequireDefault(_joi);

var _mongodb = require('mongodb');

var _express = require('express');

var _makeenRouter = require('makeen-router');

var _injectServices = require('../middlewares/injectServices');

var _injectServices2 = _interopRequireDefault(_injectServices);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const wrapHandler = _makeenRouter.helpers.wrapHandler,
      idValidator = _makeenRouter.helpers.idValidator;

exports.default = ({ uploadMiddleware }) => {
  const router = (0, _express.Router)();

  router.use(_injectServices2.default);

  router.param('id', (() => {
    var _ref = _asyncToGenerator(function* (req, res, next, rawId) {
      var _Joi$validate = _joi2.default.validate(rawId, idValidator);

      const error = _Joi$validate.error,
            value = _Joi$validate.value;


      if (error) {
        return next(error);
      }

      const id = (0, _mongodb.ObjectID)(value);

      try {
        const file = yield req.services.FileRepository.findById(id);

        if (!file) {
          return next(_boom2.default.notFound(`Unable to find entity with id ${rawId}`));
        }

        req.fileEntity = file;
      } catch (err) {
        return next(err);
      }

      return next();
    });

    return function (_x, _x2, _x3, _x4) {
      return _ref.apply(this, arguments);
    };
  })());

  router.post('/files/upload', uploadMiddleware.single('file'), wrapHandler(req => req.services.File.createFromUpload({
    filename: req.file.originalname,
    path: req.file.path,
    size: req.file.size,
    mimeType: req.file.mimetype,
    uploadDir: req.file.destination
  })));

  router.get('/files/:id/download', (() => {
    var _ref2 = _asyncToGenerator(function* (req, res, next) {
      try {
        const filePath = yield req.services.File.getPath({
          file: req.fileEntity
        });
        res.sendFile(filePath);
      } catch (err) {
        next(err);
      }
    });

    return function (_x5, _x6, _x7) {
      return _ref2.apply(this, arguments);
    };
  })());

  return router;
};