'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _dec, _dec2, _dec3, _desc, _value, _class;

var _joi = require('joi');

var _joi2 = _interopRequireDefault(_joi);

var _octobus = require('octobus.js');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

const service = _octobus.decorators.service,
      withSchema = _octobus.decorators.withSchema;
let File = (_dec = service(), _dec2 = withSchema({
  filename: _joi2.default.string().required(),
  path: _joi2.default.string().required(),
  size: _joi2.default.number().required(),
  mimeType: _joi2.default.string().required(),
  uploadDir: _joi2.default.string(),
  meta: _joi2.default.object()
}), _dec3 = service(), (_class = class File extends _octobus.ServiceContainer {
  constructor({ uploadDir }) {
    super();
    this.uploadDir = uploadDir;
  }

  setServiceBus(...args) {
    super.setServiceBus(...args);
    this.FileRepository = this.extract('FileRepository');
  }

  createFromUpload({
    path: uploadPath,
    filename,
    size,
    mimeType,
    uploadDir
  }) {
    var _this = this;

    return _asyncToGenerator(function* () {
      const file = yield _this.FileRepository.createOne({
        filename: _path2.default.basename(filename),
        extension: _path2.default.extname(filename),
        size,
        mimeType,
        uploadedAt: new Date()
      });

      const destination = yield _this.getPath({ file, uploadDir });

      yield _fsExtra2.default.rename(uploadPath, destination);

      return file;
    })();
  }

  getPath({ file, uploadDir }) {
    return _path2.default.join(uploadDir || this.uploadDir, `${file._id}${file.extension}`);
  }
}, (_applyDecoratedDescriptor(_class.prototype, 'createFromUpload', [_dec, _dec2], Object.getOwnPropertyDescriptor(_class.prototype, 'createFromUpload'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'getPath', [_dec3], Object.getOwnPropertyDescriptor(_class.prototype, 'getPath'), _class.prototype)), _class));
exports.default = File;