'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _dec, _dec2, _desc, _value, _class;

var _octobus = require('octobus.js');

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _mongodb = require('mongodb');

var _makeenMongodb = require('makeen-mongodb');

var _file = require('../schemas/file');

var _file2 = _interopRequireDefault(_file);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

const service = _octobus.decorators.service;
let FileRepository = (_dec = service(), _dec2 = service(), (_class = class FileRepository extends _makeenMongodb.Repository {
  constructor() {
    super(_file2.default);
  }

  setServiceBus(serviceBus) {
    super.setServiceBus(serviceBus);
    this.File = serviceBus.extract('File');
  }

  deleteMany(params) {
    var _this = this;

    return _asyncToGenerator(function* () {
      const query = params.query;

      const files = yield _this.findMany({
        query,
        fields: ['extension']
      }).toArray();

      const result = yield _makeenMongodb.Repository.prototype.deleteMany.call(_this, params);

      if (Array.isArray(files) && files.length) {
        yield Promise.all(files.map(function (file) {
          return _this.File.getPath({ file }).then(function (path) {
            return _fsExtra2.default.unlink(path);
          });
        }));
      }

      return result;
    })();
  }

  deleteOne(params) {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      let file;

      if (params instanceof _mongodb.ObjectID) {
        file = yield _this2.findById(params);
      } else {
        file = yield _this2.findOne({ query: params.query });
      }

      const result = yield _makeenMongodb.Repository.prototype.deleteOne.call(_this2, params);

      if (file) {
        yield _fsExtra2.default.unlink((yield _this2.File.getPath(file)));
      }

      return result;
    })();
  }
}, (_applyDecoratedDescriptor(_class.prototype, 'deleteMany', [_dec], Object.getOwnPropertyDescriptor(_class.prototype, 'deleteMany'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'deleteOne', [_dec2], Object.getOwnPropertyDescriptor(_class.prototype, 'deleteOne'), _class.prototype)), _class));
exports.default = FileRepository;